﻿using Luski.net.Enums;
using System.Threading.Tasks;

namespace Luski.net.Interfaces;

/// <summary>
/// Represents the curent user
/// </summary>
public interface IUser
{
    /// <summary>
    /// The current Id of the user
    /// </summary>
    long Id { get; }
    /// <summary>
    /// The cerrent username of the user
    /// </summary>
    string Username { get; }
    /// <summary>
    /// The current tag for the user
    /// <para>Ex: #1234</para>
    /// </summary>
    //short Tag { get; }
    /// <summary>
    /// The current status of the user
    /// </summary>
    UserStatus Status { get; }
    /// <summary>
    /// will returen the picture type of the user
    /// </summary>
    PictureType PictureType { get; }
    /// <summary>
    /// the current flags of a user
    /// </summary>
    UserFlag Flags { get; }
    /// <summary>
    /// Gets the current avatar of the user
    /// </summary>
    Task<byte[]> GetAvatar();
    /// <summary>
    /// Gets the current user key
    /// </summary>
    /// <returns></returns>
    Task<string> GetUserKey();
}
